//***************************************************************************
//
//  ̧......: vcard.c
//  ......: ATMEL Norway
//  Ώ......: ATmega169
//  ߲....: IAR EWAAVR 2.28a
//  e......: AVR Butterfly Dٰ
//  Ŕԍ....: 1.0
//
//  N   - VER. - 											- 
//  20030116 - 1.0  - 쐬											- LHM
//
//***************************************************************************

#include <inavr.h>
#include "iom169.h"
#include "main.h"
#include "button.h"
#include "LCD_functions.h"
#include "usart.h"
#include "eeprom.h"
#include "vcard.h"

/* ϐ` */

char index = 0;															// o^޲Đ
extern char gUART;														// USARTgp׸(main.cŎgp)
char Name[STRLENGHT];													// Oޯ̧

__flash char TEXT_WAIT[] = "waiting for input on RS232";				//

//*****************************************************************************
//*
//*	֐	: vCard
//*		: char input (ޮèԔԍ)
//*	߂l	: char ST_state (S̏Ԕԍ)
//*	ړI	: EEPROMo^ςݖOLCDɕ\
//*
//*****************************************************************************

char vCard(char input)
{
	static char enter = 1;												// ׸

	if (enter)															/* 񎞏 */
	{
		enter = 0;														// ׸މ
		__EEGET(index, EEPROM_START);									// EEPROMo^ςݕ޲Đ擾
		if((index < 1) | (index > STRLENGHT))							/* (o^܂͕s) */
		{
			index = 0;													// o^޲Đ
			Name[0] = 'A';												// 擪'A'ݒ(ҏWp)
			enter = 1;													// ׸ސݒ
			return ST_VCARD_ENTER_NAME;									// "O"ƭԔԍƋɕA
		}
		else															/* (Lo^) */
		{
			LoadEEPROM(Name, index, EEPROM_START + 1);					// EEPROMo^𕶎ޯ̧Ɏ擾
			LCD_puts(Name, 1);											// ޯ̧eLCDޯ̧֓]
		}
	}
	else if (input == KEY_NEXT)											/* ޮèON */
	{
		enter = 1;														// ׸ސݒ
		return ST_VCARD_ENTER_NAME;										// "O"ƭԔԍƋɕA
	}
	else if (input == KEY_PREV)											/* ޮèON */
	{
		enter = 1;														// ׸ސݒ
		return ST_VCARD;												// "O"ƭԔԍƋɕA
	}
	return ST_VCARD_FUNC;												// O\ԔԍƋɕA
}

//*****************************************************************************
//*
//*	֐	: EnterName
//*		: char input (ޮèԔԍ)
//*	߂l	: char ST_state (S̏Ԕԍ)
//*	ړI	: O͏ (:ړ,:ύX)
//*
//*****************************************************************************

char EnterName(char input)
{
	static char enter = 1;												// ׸
	static char temp_index = 0;											// Ɨpʒu/޲Đ
	static char temp_name[6];											// ƕޯ̧
	char i;																// Ɨp

	if (enter)															/* 񎞏 */
	{
		LoadEEPROM(Name, index, EEPROM_START + 1);						// EEPROMo^𕶎ޯ̧Ɏ擾
		if(index)														// ȂAŏI_ł̂߂ɕ޲Đ-1
			index -= 1;
		enter = 0;														// ׸މ
	}
	else																/* ȊO */
	{
		temp_index = index;												// Ɨpʒu/޲Đݒ
		for(i = 5; (i != 255); i--, temp_index--)						/* (sƒu) */
		{
			if ((Name[temp_index] >= ' ') && (Name[temp_index] <= 'z') && (temp_index != 255))
				temp_name[i] = Name[temp_index];						// LȂAƕޯ̧֕
			else														// ȂA󔒕ƕޯ̧֐ݒ
				temp_name[i] = ' ';
		}
		LCD_putc(0, temp_name[0]);										// LCDޯ̧1ɍƕޯ̧1ݒ
		LCD_putc(1, temp_name[1]);										// LCDޯ̧2ɍƕޯ̧2ݒ
		LCD_putc(2, temp_name[2]);										// LCDޯ̧3ɍƕޯ̧3ݒ
		LCD_putc(3, temp_name[3]);										// LCDޯ̧4ɍƕޯ̧4ݒ
		LCD_putc(4, temp_name[4]);										// LCDޯ̧5ɍƕޯ̧5ݒ
		LCD_putc(5, temp_name[5] | 0x80);								// LCDޯ̧6ɍƕޯ̧6_ŎwŐݒ
		LCD_putc(6, '\0');												// LCDޯ̧7ɏIqݒ
		if (input != KEY_NULL)											// ꂩ̽ONȂALCD_Ŏv
			LCD_FlashReset();
		LCD_UpdateRequired(TRUE, 0);									// LCD\XV׸ސݒ
	}
	if (input != KEY_NULL)												// ꂩ̽ONȂALCD_Ŏv
		LCD_FlashReset();
	if (input == KEY_PLUS)												/* ޮèON */
	{
		Name[index]--;													// Ή-1
		if( (('!' <= Name[index]) && (Name[index] <= '/')) && (Name[index] != ' '))
			Name[index] = ' ';											// O'0'ȂAΉޯ̧ɋ󔒕ݒ
		else if( (':' <= Name[index]) && (Name[index] <= '@'))			// O'A'ȂAΉޯ̧'9'ݒ
			Name[index] = '9';
		else if(Name[index] >= '[')										// OȂAΉޯ̧'Z'ݒ
			Name[index] = 'Z';
		else if(Name[index] < ' ')										// O' 'ȂAΉޯ̧'Z'ݒ
			Name[index] = 'Z';
	}
	else if (input == KEY_MINUS)										/* ޮèON */
	{
		Name[index]++;													// Ή+1
		if( (('!' <= Name[index]) && (Name[index] <= '/')) && (Name[index] != ' '))
			Name[index] = '0';											// O' 'ȂAΉޯ̧'0'ݒ
		else if( (':' <= Name[index]) && (Name[index] <= '@'))			// O'9'ȂAΉޯ̧'A'ݒ
			Name[index] = 'A';
		else if(Name[index] >= '[')										// O'Z'ȂAΉޯ̧ɋ󔒕ݒ
			Name[index] = ' ';
		else if(Name[index] < ' ')										// OsȂAΉޯ̧ɋ󔒕ݒ
			Name[index] = ' ';
	}
	else if (input == KEY_PREV)											/* ޮèON */
	{
		if(index)														// ʒu/޲Đ擪ȊOȂA
		{
			index--;													// ʒu/޲Đ
		}
	}
	else if (input == KEY_NEXT)											/* ޮèON */
	{
		if(index < STRLENGHT)											// ʒu/޲ĐőlȂA
		{
			index++;													// ʒu/޲Đis
			Name[index] = 'A';											// Ήޯ̧ɏݒ
		}
	}
	else if (input == KEY_ENTER)										/* ޮèON */
	{
		index++;														// ʒu/޲Đis(Iqp)
		Name[index] = '\0';												// ŏIL̎ɏIqݒ
        
		__EEPUT(EEPROM_START, index);									// o^޲ĐEEPROM
		StoreEEPROM(Name, index, EEPROM_START + 1);						// Oޯ̧eEEPROMɕۑ()
		enter = 1;														// ׸ސݒ
		return ST_VCARD_FUNC;											// O\ԔԍƋɕA
	}
	return ST_VCARD_ENTER_NAME_FUNC;									// O͏ԔԍƋɕA
}

//*****************************************************************************
//*
//*	֐	: RS232
//*		: char input (ޮèԔԍ)
//*	߂l	: char ST_state (S̏Ԕԍ)
//*	ړI	: USARToREEPROM֖Oo^
//*
//*****************************************************************************

char RS232(char input)
{
	static char enter = 1;												// ׸
	char c;																// USARTMl
	static char buffer[STRLENGHT];										// Mޯ̧
	static char temp_index;												// Mʒu/޲Đ

	if (enter)															/* 񎞏 */
	{
		__disable_interrupt();											// S荞݋֎~
		CLKPR = (1<<CLKPCE);											// OulύXޯĐݒ
		CLKPR = (1<<CLKPS1);											// 4Ou ۯݒ(8MHz/4=2MHz):19200bpsgp̂
		__enable_interrupt();											// S荞ݍċ
		LCD_puts_f(TEXT_WAIT, 0);
		enter = 0;														// ׸މ
		temp_index = 0													// 
		c = UDR0;														// USARTMޯ̧̂ߋǂ
		gUART = TRUE;													// USARTgp׸ސݒ
	}
	/* 񏈗 */
	if (UCSR0A & (1<<RXC0))												/* USARTM */
	{
		c = UDR0;														// USARTMl擾
		if (c != '\r')													/* (A(CR)ȊO) */
		{
			if (temp_index < STRLENGHT)									// M޲ĐȓȂA
				buffer[temp_index++] = c;								// Mޯ̧ɎMlݒ襎Mʒu/޲Đis
		}
		else															/* (A(CR)(=I)) */
		{
			__disable_interrupt();										// S荞݋֎~
			CLKPR = (1<<CLKPCE);										// OulύXޯĐݒ
			CLKPR = (1<<CLKPS1) | (1<<CLKPS0);							// 8Ou ۯݒ(8MHz/8=1MHz)
			__enable_interrupt();										// S荞ݍċ
			if(temp_index)												/* ((M莞)) */
			{
				buffer[temp_index] = '\0';								// Mޯ̧ŏIM̎ɏIqݒ
				for (temp_index = 0; buffer[temp_index]; temp_index++)	// Mޯ̧e𖼑Oޯ̧ɓ]
					Name[temp_index] = buffer[temp_index];
				Name[temp_index] = '\0';								// Oޯ̧ŏIM̎ɏIqݒ
				enter = 1;												// ׸ސݒ
				__EEPUT(EEPROM_START, temp_index);						// o^޲ĐEEPROM
				StoreEEPROM(Name, temp_index, EEPROM_START + 1);		// Oޯ̧eEEPROMɕۑ()
				index = temp_index;										// o^޲Đ
				gUART = FALSE;											// USARTgp׸މ
				return ST_VCARD_FUNC;									// O\ԔԍƋɕA
			}
			else														/* ((MȂ)) */
			{
				enter = 1;												// ׸ސݒ
				return ST_VCARD_DOWNLOAD_NAME;							// "RS232O"ƭԔԍƋɕA
			}
		}
	}
	if (input != KEY_NULL)												/* ꂩ̽ON */
	{
		enter = 1;														// ׸ސݒ
		__disable_interrupt();											// S荞݋֎~
		CLKPR = (1<<CLKPCE);											// OulύXޯĐݒ
		CLKPR = (1<<CLKPS1) | (1<<CLKPS0);								// 8Ou ۯݒ(8MHz/8=1MHz)
		__enable_interrupt();											// S荞ݍċ
		gUART = FALSE;													// USARTgp׸މ
		return ST_VCARD_DOWNLOAD_NAME;									// "RS232O"ƭԔԍƋɕA
	}
	return ST_VCARD_DOWNLOAD_NAME_FUNC;									// RS232O͏ԔԍƋɕA
}
